码迷,mamicode.com
首页 > 编程语言 > 详细

Leetcode No.27 Remove Element(c++实现)

时间:2021-06-25 17:23:46      阅读:0      评论:0      收藏:0      [点我收藏+]

标签:hang   placed   ssi   遍历   找不到   复杂度   pointer   针对   his   

1. 题目

1.1 英文题目

Given an integer array nums and an integer val, remove all occurrences of val in nums in-place. The relative order of the elements may be changed.

Since it is impossible to change the length of the array in some languages, you must instead have the result be placed in the first part of the array nums. More formally, if there are k elements after removing the duplicates, then the first k elements of nums should hold the final result. It does not matter what you leave beyond the first k elements.

Return k after placing the final result in the first k slots of nums.

Do not allocate extra space for another array. You must do this by modifying the input array in-place with O(1) extra memory.

1.2 中文题目

给你一个数组 nums 和一个值 val,你需要 原地 移除所有数值等于 val 的元素,并返回移除后数组的新长度。

不要使用额外的数组空间,你必须仅使用 O(1) 额外空间并 原地 修改输入数组。

元素的顺序可以改变。你不需要考虑数组中超出新长度后面的元素。

1.3输入输出

输入 输出
nums = [3,2,2,3], val = 3 2, nums = [2,2,,]
nums = [0,1,2,2,3,0,4,2], val = 2 5, nums = [0,1,4,0,3,,,_]

2. 实验平台

IDE:VS2019
IDE版本:16.10.1
语言:c++11

3. 程序

3.1 测试程序

#include "Solution.h"
#include <vector>	// std::vector
#include<iostream>	// std::cout
using namespace std;

// 主程序
void main()
{
	// // 输入
	vector<int> nums = { 0,1,2,2,3,0,4,2 }; 
	int val = 2;

	Solution solution; // 实例化Solution
	int k = solution.removeElement(nums, val); // 主功能

	// 输出
	cout << k << ", [";
	for (int i = 0; i < k; i++)
	{
		if (i == k - 1)
			cout << nums[i] << "]";
		else
			cout << nums[i] << ",";
	}
}

3.2 功能程序

3.2.1 最佳程序

(1)代码

#pragma once
#include<vector>    // std::vector
using namespace std;

//主功能(快慢指针法,双指针法)
class Solution 
{
public:
    int removeElement(vector<int>& nums, int val) 
    {
        int res = 0; // 存储去重后数组元素个数
        for (int i = 0; i < nums.size(); ++i) // 快指针i遍历数组
            if (nums[i] != val) // 若快指针指向元素不是目标元素
                nums[res++] = nums[i]; // 则慢指针res+1,且慢指针指向快指针当前元素
        return res;
    }
};

此程序参考:https://www.cnblogs.com/lightwindy/p/8628297.html

(2)解读

快慢指针对于这种O(1)空间复杂度的数组问题真的很好用,虽然菜鸡的我还没有掌握它的灵魂,废话不多说。这个方法用的快慢指针法,也叫双指针法。res作为慢指针,始终指向的是去重后的数组元素,而i作为快指针,一马当先,遍历整个数组。如果快指针指向的元素不是目标元素,也就是去重元素,就让慢指针+1,同时指向该元素。i遍历一遍,算法结束。
解读参考:https://www.cnblogs.com/forPrometheus-jun/p/10889152.html

3.2.2 自写程序

(1)代码

#pragma once
#include<vector>    // std::vector
using namespace std;

//主功能
class Solution 
{
public:
    int removeElement(vector<int>& nums, int val) 
    {
        while(1)
        {
            vector<int>::iterator iter = find(nums.begin(), nums.end(), val); // 在数组中找到目标元素
            if (iter != nums.end()) // 若找到
                nums.erase(iter); // 则删除该元素
            else // 若找不到,即数组中不存在该目标元素,则不再查找
                break;
        }
        return nums.size();
    }
};

(2)思路

菜鸡的我只想到暴力算法,遍历整个数组,遇到去重元素,就删除该元素。遍历完后,返回去重后数组长度即可。
从前往后遍历,如果发现有元素重复,则将重复元素剔除

4. 相关知识

(1) 快慢指针(Fast-Slow Pointer)

关于快慢指针,Leetcode的26题也用到了该算法,这个算法真不错,26题的该算法解法可以参考:https://www.cnblogs.com/yunmeng-shi/p/14927735.html

Leetcode No.27 Remove Element(c++实现)

标签:hang   placed   ssi   遍历   找不到   复杂度   pointer   针对   his   

原文地址:https://www.cnblogs.com/yunmeng-shi/p/14930945.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!